﻿EnableExplicit

Structure sade
    x.f 
    y.f 
    u.f 
    v.f 
  elu.f 
    s.f 
EndStructure 

Global Event, AreeniLaius=600,AreeniKorgus=400, Lopp.b, SK=AreeniLaius/400
Global PalliRaadius.d=AreeniLaius/40, Px.d=AreeniLaius/2, Py.d=AreeniKorgus/2
Global PKx.d=-1, PKy.d=Random(4,1), PalliVarv=RGBA(255,0,0,255)
Global ReketiKorgus.d=6*PalliRaadius, ReketiLaius.d=PalliRaadius, ReketiY.d=AreeniKorgus/2
Global ReketiVarv=RGBA(0,150,0,255), ReketiLook, MaksVaravaid=15, MangLabi.b
Global Kell.s, AlgusAeg.q=ElapsedMilliseconds(), Aeg, Varavaid, Pyytud, Skoor.s="---"
Global AiTarkus.d=Random(20,10)/10, Ai.b=#True, AiVarv, AiTekst.s, AiVarviSuund.b=1, EelmineAsukoht.d
Global NewList Sademed.sade(), VaravaRaadius.d=AreeniLaius/10/2+Pow(AreeniKorgus,2)/(8*(AreeniLaius/10))

#Aken    = 0
#Areen   = 0
#AiTekst = "HOIATUS! Siin majandab tehisintellekt..."
#AiOhjad = "Ohjade haaramiseks klikka areenile..."
#Lopp    = "Finito!"

LoadFont(0,"Lucida Console",20,#PB_Font_HighQuality)
LoadFont(1,"Lucida Console",40,#PB_Font_HighQuality|#PB_Font_Bold)
LoadFont(2,"Lucida Handwriting",40,#PB_Font_HighQuality)

Enumeration 
  #p1
  #p2
  #p3
  #p4
  #p5
  #p6
  #p7
  #p8
  #m
EndEnumeration

DataSection
  p1:
  IncludeBinary "p1.wav"
  p2:
  IncludeBinary "p2.wav"
  p3:
  IncludeBinary "p3.wav"
  p4:
  IncludeBinary "p4.wav"
  p5:
  IncludeBinary "p5.wav"
  p6:
  IncludeBinary "p6.wav"
  p7:
  IncludeBinary "p7.wav"
  p8:
  IncludeBinary "p8.wav"
  m:
  IncludeBinary "m.wav"
  Lopp:
EndDataSection

InitSound()
CatchSound(#p1,?p1)
CatchSound(#p2,?p2)
CatchSound(#p3,?p3)
CatchSound(#p4,?p4)
CatchSound(#p5,?p5)
CatchSound(#p6,?p6)
CatchSound(#p7,?p7)
CatchSound(#p8,?p8)
CatchSound(#m,?m)

Procedure SyytaSade(x,y,Laiali.l=256) 
  Protected Nurk.f,g.l, Sademeid.l
  Sademeid=5*(Abs(-Abs(pkx))-1)
  For g=1 To Sademeid 
    AddElement(Sademed()) 
    Nurk.f=Random(359)*3.141592/180 
    Sademed()\elu=1+Random(64) 
    Sademed()\u=Cos(Nurk)*Random(128)/Laiali 
    Sademed()\v=Sin(Nurk)*Random(128)/Laiali 
    Sademed()\v=Sademed()\v-1 
    Sademed()\x=x 
    Sademed()\y=y 
    Sademed()\s=Random(15)/10 
  Next g 
EndProcedure 

Procedure Porge(Sein.s="X")
  Protected Noot
  If Sein="X"
    Noot=px/(AreeniLaius/8)+1
  ElseIf Sein="R"
    Noot=Abs(ReketiY-py)/((ReketiKorgus/2)/8)+1 
  Else
    Noot=py/(AreeniKorgus/8)+1
  EndIf
  If noot > 8 :noot = 8 : EndIf
  Select noot
      Case 1
        PlaySound(#p1,#PB_Sound_MultiChannel)
      Case 2
        PlaySound(#p2,#PB_Sound_MultiChannel)
      Case 3
        PlaySound(#p3,#PB_Sound_MultiChannel)
      Case 4
        PlaySound(#p4,#PB_Sound_MultiChannel)
      Case 5
        PlaySound(#p5,#PB_Sound_MultiChannel)
      Case 6
        PlaySound(#p6,#PB_Sound_MultiChannel)
      Case 7
        PlaySound(#p7,#PB_Sound_MultiChannel)
      Case 8
        PlaySound(#p8,#PB_Sound_MultiChannel)
  EndSelect      
EndProcedure

Procedure.s SekundidKellaks()
  If Not MangLabi
    Aeg=(ElapsedMilliseconds()-AlgusAeg)/1000
  EndIf
  Protected Sek=Mod(Aeg,60), Minutid=aeg/60
  ProcedureReturn RSet(Str(Minutid),2,"0")+":"+RSet(Str(Sek),2,"0")
EndProcedure

Macro  PunktiArvestus
  skoor=Str(Int(aeg/((Varavaid+1)/Pyytud)))
EndMacro

Procedure JoonistaAreen()
  Protected I,Co
  Static J
  StartVectorDrawing(CanvasVectorOutput(#Areen))
    ;värvime tausta
    VectorSourceColor(RGBA(0,0,0,25))
    FillVectorOutput()
    VectorSourceColor(RGBA(255,255,255,100))
    MovePathCursor(AreeniLaius/2,0)
    AddPathLine(AreeniLaius/2,AreeniKorgus)
    AddPathCircle(AreeniLaius/2,AreeniKorgus/2,AreeniKorgus/4)
    AddPathCircle(AreeniLaius/10-VaravaRaadius,AreeniKorgus/2,VaravaRaadius)
    DashPath(1,6,#PB_Path_Default)
    AddPathCircle(AreeniLaius-AreeniLaius/10+VaravaRaadius,AreeniKorgus/2,VaravaRaadius)
    If px>AreeniLaius/2
      co=(px-AreeniLaius/2)/(AreeniLaius/2)*255;*0.8
    EndIf
    ;VectorSourceColor(RGBA(co,0,0,100))
    ;FillPath(#PB_Path_Preserve)
    VectorSourceCircularGradient(AreeniLaius-AreeniLaius/10+VaravaRaadius,AreeniKorgus/2,VaravaRaadius)
    VectorSourceGradientColor(RGBA(co,0,0,255),0.0)
    VectorSourceGradientColor(RGBA(0,0,0,0),1.0)
    ;FillVectorOutput()
    FillPath(#PB_Path_Preserve)
    VectorSourceColor(RGBA(255,255,255,100))
    DashPath(1,6,#PB_Path_RoundEnd,ReketiY-AreeniKorgus/2)
    ;J+1:If J>42:J=0:EndIf
    ;Näitame aega
    VectorSourceColor(RGBA(255,255,255,100))
    MovePathCursor(20,20)
    VectorFont(FontID(0),PalliRaadius*2)
    DrawVectorText(SekundidKellaks())
    ;näitame punkte
    VectorFont(FontID(1),PalliRaadius*2+8)
    MovePathCursor(AreeniLaius/2-VectorTextWidth(Skoor)/2,16)
    DrawVectorText(Skoor)
    ;näitame püütud pallide arvu
    VectorFont(FontID(1),PalliRaadius)
    VectorSourceColor(RGBA(0,255,0,200))
    MovePathCursor(AreeniLaius-20-VectorTextWidth(Str(Pyytud)),18)
    DrawVectorText(Str(Pyytud))
    ;näitame läbilipsanud pallide arvu
    VectorSourceColor(RGBA(255,0,0,200))
    MovePathCursor(AreeniLaius-20-VectorTextWidth(Str(Varavaid)),18+PalliRaadius+4)
    DrawVectorText(Str(Varavaid))
    ;kui vaja, kuvame tehisintellekti teavituse
    If ai
      VectorSourceColor(RGBA(0,0,AiVarv,AiVarv))  
      If AiVarv=0
        If AiTekst=#AiTekst
          AiTekst=#AiOhjad
        Else
          AiTekst=#AiTekst
        EndIf
      EndIf
        MovePathCursor(AreeniLaius/2-VectorTextWidth(AiTekst)/2,AreeniKorgus-PalliRaadius*2)
        DrawVectorText(AiTekst)
      AiVarv+AiVarviSuund
      If AiVarv=255 Or AiVarv=0:AiVarviSuund*-1:EndIf
    EndIf
    ;joonistame palli
    VectorSourceColor(PalliVarv)
    AddPathCircle(Px,Py,PalliRaadius)
    FillPath()
    ;joonistame reketi
    VectorSourceColor(ReketiVarv)
    ;AddPathBox(AreeniLaius-ReketiLaius-2+ReketiLook,ReketiY-ReketiKorgus/2,ReketiLaius,ReketiKorgus)
    AddPathCircle(AreeniLaius-ReketiLaius+ReketiLaius/2-2+ReketiLook,ReketiY-ReketiKorgus/2+ReketiLaius/2,ReketiLaius/2)
    AddPathCircle(AreeniLaius-ReketiLaius+ReketiLaius/2-2+ReketiLook,ReketiY-ReketiKorgus/2+ReketiLaius/2+ReketiKorgus-ReketiLaius,ReketiLaius/2)
    FillPath()
    AddPathBox(AreeniLaius-ReketiLaius-2+ReketiLook,ReketiY-ReketiKorgus/2+ReketiLaius/2,ReketiLaius,ReketiKorgus-ReketiLaius)
    FillPath()
    If ReketiLook<>0:ReketiLook-1:EndIf
    ;joonistame sädemed
    If ListSize(Sademed())<>0
      Protected c
      ForEach Sademed()
        Sademed()\x+Sademed()\u 
        Sademed()\y+Sademed()\v 
        Sademed()\v+0.05 
        If Sademed()\x=>(0) And Sademed()\x<=(AreeniLaius) And Sademed()\y=>(0) And Sademed()\y<=(AreeniKorgus)
          c=Sademed()\elu 
          VectorSourceColor(RGBA(255,255,0,C*4))
          AddPathCircle(Sademed()\x,Sademed()\y,0.2)
        EndIf 
        Sademed()\elu-1:If Sademed()\elu<=0:DeleteElement(Sademed()):EndIf 
      Next
      StrokePath(2)
    EndIf
    ;kui mäng on läbi, siis teavitame
    If Varavaid=MaksVaravaid
      MangLabi=#True
      VectorSourceColor(RGBA(55,55,55,255))
      VectorFont(FontID(2),PalliRaadius*3)
      MovePathCursor(AreeniLaius/2-VectorTextWidth(#Lopp)/2,AreeniKorgus/2-VectorTextHeight(#Lopp)/2)
      DrawVectorText(#Lopp)
      If ListSize(Sademed())<1000
        SyytaSade(AreeniLaius/2,AreeniKorgus/2,64)
      EndIf
    EndIf
    StopVectorDrawing()
    If MangLabi
      ProcedureReturn 
    EndIf
    If px+PalliRaadius >= AreeniLaius-ReketiLaius-2 And (py>=ReketiY-ReketiKorgus/2 And py<=ReketiY+ReketiKorgus/2)
      pkx +0.1
      pkx *-1
      pky + Abs(ReketiY-py)/PalliRaadius*Sign(ReketiY-py)
      Porge("R")
      AiTarkus.d=Random(20,10)/10
      Pyytud+1
      PunktiArvestus
      SyytaSade(AreeniLaius-ReketiLaius-5,py)
      For i=0 To 7
        SyytaSade(AreeniLaius-3,ReketiY-ReketiKorgus/2+i*ReketiKorgus/7)
      Next
      ReketiLook=3
    EndIf
    If Px+PalliRaadius >= AreeniLaius 
      Px=PalliRaadius+1
      PlaySound(#m,#PB_Sound_MultiChannel)
      Varavaid+1
      PunktiArvestus
      AiTarkus.d=Random(20,10)/10
    EndIf
  If Px-PalliRaadius <=0            :PKx *-1:SyytaSade(px-PalliRaadius/2,py):PKy+(0.5-Random(20)/20):Porge("Y"):EndIf
  If Py+PalliRaadius >= AreeniKorgus:PKy *-1:SyytaSade(px,py+PalliRaadius):Porge():EndIf
  If Py-PalliRaadius <=0            :PKy *-1:SyytaSade(px,py):Porge():EndIf
  EelmineAsukoht=Px
  If Abs(pky)<1:pky=1*Sign(pky):EndIf
  Px + PKx*SK
  Py + PKy
EndProcedure  

OpenWindow(0,10,10,AreeniLaius,AreeniKorgus,"Ping-Pong",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
CanvasGadget(#Areen,0,0,AreeniLaius,AreeniKorgus,#PB_Canvas_Keyboard)
SetActiveGadget(#Areen)
AddWindowTimer(#Aken, 100, 1)

BindEvent(#PB_Event_Timer, @JoonistaAreen())
Repeat
  Event = WaitWindowEvent(1000)
  If Event=#PB_Event_Gadget
    If EventGadget()=#Areen
      Select EventType()
        Case #PB_EventType_KeyDown
          If GetGadgetAttribute(#Areen,#PB_Canvas_Key)=#PB_Shortcut_Escape:Lopp=#True:EndIf
        Case #PB_EventType_MouseMove
          ReketiY=GetGadgetAttribute(#Areen,#PB_Canvas_MouseY)
          If ReketiY<=ReketiKorgus/2
            ReketiY=ReketiKorgus/2
          ElseIf ReketiY>=AreeniKorgus-ReketiKorgus/2
            ReketiY=AreeniKorgus-ReketiKorgus/2
          EndIf
        Case #PB_EventType_LeftClick
          Ai=#False
          pkx=Sign(pkx)*1
          Pyytud=0
          Varavaid=0
          Skoor="Uus mäng!"
          AlgusAeg.q=ElapsedMilliseconds()
          MangLabi=#False
      EndSelect
    EndIf
  EndIf
  If Event = #PB_Event_CloseWindow:Lopp=#True:EndIf
  ;tehisinntellekt mõllab
  If Ai
    If px>AreeniLaius/2 And EelmineAsukoht<px
      If py<ReketiY
        ReketiY-(Log10(px)-Log10(AreeniLaius/2))*5*sk
      Else
        ReketiY+(Log10(px)-Log10(AreeniLaius/2))*5*sk
      EndIf
      If ReketiY>AreeniKorgus-ReketiKorgus/2:ReketiY=AreeniKorgus-ReketiKorgus/2:EndIf
      If ReketiY<ReketiKorgus/2:ReketiY=ReketiKorgus/2:EndIf
    Else
      If ReketiY<AreeniKorgus/2
        ReketiY+0.25
      Else
        ReketiY-0.25
      EndIf  
    EndIf
  EndIf
Until Lopp
; IDE Options = PureBasic 5.60 beta 6 (Windows - x86)
; CursorPosition = 40
; FirstLine = 39
; Folding = A-
; EnableXP
; EnableOnError
; UseIcon = folder-icon.ico
; Executable = PingPong.exe
; CompileSourceDirectory
; EnableCompileCount = 599
; EnableBuildCount = 11
; EnableExeConstant
; Watchlist = PKy;PKx